;CodeVisionAVR C Compiler V1.24.2c Standard
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : AT90S2313
;Clock frequency     : 11.000000 MHz
;Memory model        : Tiny
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 32 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.DEVICE AT90S2313
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x10

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "test.vec"
	.INCLUDE "test.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80
;       1 //Chip type           : AT90S2313
;       2 //Clock frequency     : 11.059000 MHz
;       3 //Memory model        : Tiny
;       4 //External SRAM size  : 0
;       5 //Data Stack size     : 32
;       6 //*********************************************/
;       7 /*Algorithm:
;       8 ' Interrupt on both edges of phase A
;       9 ' Test phase B in ISR
;      10 ' When phase B <> phase A then decrement counter
;      11 ' When phase B = phase A then increment counter
;      12 ' Convert counter value to displacment units
;      13 ' Format value in string and display
;      14 '
;      15 '-------------------------------------------------------------------------------
;      16 '
;      17 ' Setup for AT90S2313-10
;      18 '
;      19 ' INT0 edge is set to rising edge
;      20 ' INT1 edge is set to falling edge
;      21 ' Encoder phase A to INT0 and INT1  (PD2 and PD3)
;      22 ' Encoder phase B to PD4
;      23 ' Pushbutton between Portd.5 and GND  (display zero)
;      24 ' LCD at PortB
;      25 */
;      26 #include <90s2313.h>
;      27 #define TRUE 1
;      28 #define FALSE 0
;      29 #define Phase_a PIND.2                   // 'INT0 also connected to Pind.3 = INT1
;      30 #define Phase_b PIND.4
;      31 
;      32 
;      33 
;      34 bit  Rem_phase_a ;  //current encoder state memory
;      35 bit  Rem_phase_b ;  //current encoder state memory
;      36 signed long int encoder_counter1;
_encoder_counter1:
	.BYTE 0x4
;      37 unsigned char command, count;
;      38 
;      39 /* union declaration */
;      40 union alpha {
;      41             unsigned char byte[4];
;      42             signed long int encoder_counter2 ;
;      43             } data;
_data:
	.BYTE 0x4
;      44 /////////////////////////////////////////////////////////////////////
;      45 
;      46 void Calculate_step()
;      47 {

	.CSEG
_Calculate_step:
;      48 //test level of A and B phases again to protect chip from accidental noise
;      49 if ((Rem_phase_a != Phase_a || Rem_phase_b != Phase_b) && (Rem_phase_a !=  Phase_a || Rem_phase_b != Phase_b)) // O.K, something really changed in levels 
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
	PUSH R30
	LDI  R30,0
	SBIC 0x10,2
	LDI  R30,1
	POP  R26
	CP   R30,R26
	BRNE _0x4
	LDI  R30,0
	SBRC R2,1
	LDI  R30,1
	PUSH R30
	LDI  R30,0
	SBIC 0x10,4
	LDI  R30,1
	POP  R26
	CP   R30,R26
	BREQ _0x6
_0x4:
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
	PUSH R30
	LDI  R30,0
	SBIC 0x10,2
	LDI  R30,1
	POP  R26
	CP   R30,R26
	BRNE _0x7
	LDI  R30,0
	SBRC R2,1
	LDI  R30,1
	PUSH R30
	LDI  R30,0
	SBIC 0x10,4
	LDI  R30,1
	POP  R26
	CP   R30,R26
	BREQ _0x6
_0x7:
	RJMP _0x9
_0x6:
	RJMP _0x3
_0x9:
;      50   {
;      51 	if (Phase_a == Phase_b) encoder_counter1++;
	LDI  R30,0
	SBIC 0x10,2
	LDI  R30,1
	PUSH R30
	LDI  R30,0
	SBIC 0x10,4
	LDI  R30,1
	POP  R26
	CP   R30,R26
	BRNE _0xA
	LDS  R30,_encoder_counter1
	LDS  R31,_encoder_counter1+1
	LDS  R22,_encoder_counter1+2
	LDS  R23,_encoder_counter1+3
	__SUBD1N -1
	RJMP _0x1F
;      52 	else encoder_counter1--;
_0xA:
	LDS  R30,_encoder_counter1
	LDS  R31,_encoder_counter1+1
	LDS  R22,_encoder_counter1+2
	LDS  R23,_encoder_counter1+3
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
_0x1F:
	STS  _encoder_counter1,R30
	STS  _encoder_counter1+1,R31
	STS  _encoder_counter1+2,R22
	STS  _encoder_counter1+3,R23
;      53 
;      54    Rem_phase_a =  Phase_a; // remember current state
	CLT
	SBIC 0x10,2
	SET
	BLD  R2,0
;      55    Rem_phase_b =  Phase_b;   // remember current state
	CLT
	SBIC 0x10,4
	SET
	BLD  R2,1
;      56   }
;      57 
;      58 }
_0x3:
	RET
;      59 
;      60 ///////////////////////////////////////////////////////////////////
;      61 // External Interrupt 0 service routine
;      62 interrupt [EXT_INT0] void ext_int0_isr(void)
;      63 {
_ext_int0_isr:
	RCALL SUBOPT_0x0
;      64 // Place your code here
;      65 Calculate_step();
;      66 }
	RETI
;      67 
;      68 ///////////////////////////////////////////////////////////////////
;      69 // External Interrupt 1 service routine
;      70 interrupt [EXT_INT1] void ext_int1_isr(void)
;      71 {
_ext_int1_isr:
	RCALL SUBOPT_0x0
;      72 // Place your code here
;      73 Calculate_step();
;      74 }
	RETI
;      75 
;      76 ////////////////////////////////////////////////////////////////////
;      77 // Declare your global variables here
;      78 void main(void)
;      79 {
_main:
;      80 
;      81 count = 0;
	RCALL SUBOPT_0x1
;      82 encoder_counter1 = 0;
;      83 data.encoder_counter2 = 0;
	__GETD1N 0x0
	STS  _data,R30
	STS  _data+1,R31
	STS  _data+2,R22
	STS  _data+3,R23
;      84 Rem_phase_a =  Phase_a; // initialization: remember current state
	CLT
	SBIC 0x10,2
	SET
	BLD  R2,0
;      85 Rem_phase_b =Phase_b;   // initialization: remember current state
	CLT
	SBIC 0x10,4
	SET
	BLD  R2,1
;      86 
;      87 // Declare your local variables here
;      88 
;      89 // Input/Output Ports initialization
;      90 // Port B initialization
;      91 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
;      92 // State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=1 State7=1 
;      93 PORTB=0xFF;
	RCALL SUBOPT_0x2
;      94 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;      95 
;      96 
;      97 // Port D initialization
;      98 // Func0=In Func1=Out Func2=In Func3=In Func4=In Func5=In Func6=In 
;      99 // State0=T State1=1 State2=T State3=T State4=T State5=T State6=T 
;     100 PORTD=0x02;
	LDI  R30,LOW(2)
	OUT  0x12,R30
;     101 DDRD=0x02;
	OUT  0x11,R30
;     102 
;     103 
;     104 // Timer/Counter 0 initialization
;     105 // Clock source: System Clock
;     106 // Clock value: Timer 0 Stopped
;     107 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     108 TCNT0=0x00;
	OUT  0x32,R30
;     109 
;     110 // Timer/Counter 1 initialization
;     111 // Clock source: System Clock
;     112 // Clock value: Timer 1 Stopped
;     113 // Mode: Normal top=FFFFh
;     114 // OC1 output: Discon.
;     115 // Noise Canceler: Off
;     116 // Input Capture on Falling Edge
;     117 TCCR1A=0x00;
	OUT  0x2F,R30
;     118 TCCR1B=0x00;
	OUT  0x2E,R30
;     119 TCNT1H=0x00;
	OUT  0x2D,R30
;     120 TCNT1L=0x00;
	OUT  0x2C,R30
;     121 OCR1H=0x00;
	OUT  0x2B,R30
;     122 OCR1L=0x00;
	OUT  0x2A,R30
;     123 
;     124 // External Interrupt(s) initialization
;     125 // INT0: On
;     126 // INT0 Mode: Rising Edge
;     127 // INT1: On
;     128 // INT1 Mode: Falling Edge
;     129 GIMSK=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3B,R30
;     130 MCUCR=0x0B;
	LDI  R30,LOW(11)
	OUT  0x35,R30
;     131 GIFR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x3A,R30
;     132 
;     133 // Timer(s)/Counter(s) Interrupt(s) initialization
;     134 TIMSK=0x00;
	LDI  R30,LOW(0)
	OUT  0x39,R30
;     135 
;     136 // Analog Comparator initialization
;     137 // Analog Comparator: Off
;     138 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     139 // Analog Comparator Output: Off
;     140 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     141 PORTD.1 = 1;
	SBI  0x12,1
;     142 // Global enable interrupts
;     143 #asm("sei")
	sei
;     144 
;     145  while (1)  // Place your code here
_0xC:
;     146  {
;     147       if (PIND.0 == 0 && PORTD.1 == 1 )   // sihronization of transfer
	SBIC 0x10,0
	RJMP _0x10
	SBIC 0x12,1
	RJMP _0x11
_0x10:
	RJMP _0xF
_0x11:
;     148       {      
;     149         command = 0;    // reset command
	CLR  R4
;     150         //get command 00 - reset counter, 01 - read lowest byte, 10 - read next byte, which is pointed by counter, 11 - do nothing
;     151         if (PIND.5 == 0) command++;
	SBIS 0x10,5
	INC  R4
;     152         if (PIND.6 == 0) {command++;  command++; }  
	SBIC 0x10,6
	RJMP _0x13
	INC  R4
	INC  R4
;     153        //Now command = 3 - reset counter, 1 - send lowest byte, 2 - send second byte, which is pointed by counter, 0 - do nothing
;     154       
;     155         if (command == 1) //1 - send lowest byte, and set count pointer to next byte
_0x13:
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0x14
;     156         {
;     157         #asm("cli"); // disable interrupts
	cli
;     158         data.encoder_counter2 = encoder_counter1; //copy data to buffer and send lowest byte to Port B
	RCALL SUBOPT_0x3
;     159         #asm("sei"); //enable interrupts
	sei
;     160         PORTB = data.byte[0]; 
	LDS  R30,_data
	OUT  0x18,R30
;     161         PORTD.1 = 0; // data are on 
	CBI  0x12,1
;     162         count = 1;           
	LDI  R30,LOW(1)
	MOV  R5,R30
;     163         } 
;     164         
;     165         else if (command == 2) 
	RJMP _0x15
_0x14:
	LDI  R30,LOW(2)
	CP   R30,R4
	BRNE _0x16
;     166         {        
;     167               if (count == 0)  
	TST  R5
	BRNE _0x17
;     168                { 
;     169                 #asm("cli"); // disable interrupts
	cli
;     170         	data.encoder_counter2 = encoder_counter1; //copy data to buffer 
	RCALL SUBOPT_0x3
;     171         	#asm("sei"); //enable interrupts
	sei
;     172                }
;     173           PORTB = data.byte[count]; //2 - send next byte      
_0x17:
	LDI  R26,LOW(_data)
	ADD  R26,R5
	LD   R30,X
	OUT  0x18,R30
;     174           PORTD.1 = 0; // data are on PORTB ready   
	CBI  0x12,1
;     175           count++;          
	INC  R5
;     176           if (count > 3) count = 0; //there is no more to read, reset count
	LDI  R30,LOW(3)
	CP   R30,R5
	BRSH _0x18
	CLR  R5
;     177         
;     178         }
_0x18:
;     179         else if (command == 3) //3 - reset counter
	RJMP _0x19
_0x16:
	LDI  R30,LOW(3)
	CP   R30,R4
	BRNE _0x1A
;     180         {
;     181         count = 0;
	RCALL SUBOPT_0x1
;     182         encoder_counter1 = 0;         
;     183         PORTB = 0xff;
	RCALL SUBOPT_0x2
;     184         PORTD.1 = 0;
	CBI  0x12,1
;     185         }
;     186         else PORTD.1 = 0; //do nothing, just respond
	RJMP _0x1B
_0x1A:
	CBI  0x12,1
_0x1B:
_0x19:
_0x15:
;     187                          
;     188       } //end of  sihronization of transfer
;     189       else if (PIND.0 == 1)  {PORTB = 0xff; PORTD.1 = 1; } // end of transfer
	RJMP _0x1C
_0xF:
	SBIS 0x10,0
	RJMP _0x1D
	RCALL SUBOPT_0x2
	SBI  0x12,1
;     190 
;     191   } //end while(1)
_0x1D:
_0x1C:
	RJMP _0xC
;     192 } //end main
_0x1E:
	RJMP _0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RCALL _Calculate_step
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	CLR  R5
	LDI  R30,0
	STS  _encoder_counter1,R30
	STS  _encoder_counter1+1,R30
	STS  _encoder_counter1+2,R30
	STS  _encoder_counter1+3,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(255)
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDS  R30,_encoder_counter1
	LDS  R31,_encoder_counter1+1
	LDS  R22,_encoder_counter1+2
	LDS  R23,_encoder_counter1+3
	LDI  R26,LOW(_data)
	RCALL __PUTDP1
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

